import pygame
import random
from Champs import Champs,Houblon,Buisson,TerrainVide,Pesticide,typePlantation
import numpy as np
from Camera import Camera
from Image import transformImage,Image
from Temps import Temps
from Infrastructure import Infrastructure,typeBatiment,Serre,Torche

RAYON_MUR_INVISIBLE = 2000
SAISONS = ["Printemps", "Été", "Automne", "Hiver"]
MOIS = ["Janvier", "Février", "Mars", "Avril", "Mai", "Juin", "Juillet", "Août", "Septembre", "Octobre", "Novembre", "Décembre"]
police = pygame.font.SysFont("roboto", 30)

class Game:
    imagestaticplantation = pygame.image.load('../assets/Interface/imagePlantation.jpeg')
    imagestaticbatiment = pygame.image.load('../assets/Interface/imageBatiment.jpeg')
    imagestaticinfor = pygame.image.load('../assets/Interface/imageinfo.jpg')
    def __init__ (self):
        self.screen = pygame.display.set_mode((0,0), pygame.FULLSCREEN)
        self.image = Image(self.screen)
        self.screenSize = np.array(self.screen.get_size())
        self.score = 0
        self.money = 40000
        self.displayMoney = 40000
        self.month = 0

        self.champs = []
        self.batiment = []

        self.temps = Temps()
        for i in range(12):
            self.champs.append(Buisson(((i%4)*300-550,(i//4)*250-430)))
        self.clock = pygame.time.Clock()
        self.selectedChamp = None

        self.imageMoney = pygame.transform.scale(self.image.moneyImage, np.array(self.image.moneyImage.get_size())/2)

        self.camera = Camera(np.array(self.screen.get_size())/2)

        self.frame = 0
        self.buyFrame = -1000
        
        self.tourSuivantOriginal = self.image.arrowNextImage
        self.tourSuivantModif = pygame.transform.scale(self.tourSuivantOriginal, (100,100))
        self.coordonneeSuite = self.screenSize[0]-self.tourSuivantModif.get_width() - 120, self.screenSize[1] - self.tourSuivantModif.get_height() - 120
        self.suiteRectangle = pygame.rect.Rect(*self.coordonneeSuite, 100, 100)

        self.coordonne_info = pygame.rect.Rect(self.screen.get_width()*0.82,self.screen.get_height()*0.18,self.screen.get_width()*0.19,self.screen.get_height()*0.5)
        self.recInformation = pygame.rect.Rect(self.coordonne_info)
        self.rectPlantation = pygame.rect.Rect(0,0,self.temps.getImageSaison().get_width(),self.screen.get_height() -  self.temps.getImageSaison().get_height())
        self.recBatiment = pygame.rect.Rect(self.temps.getImageSaison().get_width(), self.screen.get_height() - self.temps.getImageSaison().get_height(), self.screen.get_width() * 0.65, self.temps.getImageSaison().get_height())

        self.rectPlantationimage = pygame.transform.scale(Game.imagestaticplantation,(self.rectPlantation.w,self.rectPlantation.h))
        self.rectBatimentimage = pygame.transform.scale(Game.imagestaticbatiment,(self.recBatiment.w,self.recBatiment.h))
        self.rectinfoimage = pygame.transform.scale(Game.imagestaticinfor,(self.recInformation.w,self.recInformation.h))

        self.recTourSuivant = pygame.rect.Rect(
        self.recBatiment.x + self.recBatiment.w ,self.screen.get_height() - self.temps.getImageSaison().get_height(),
        self.screen.get_width() -  self.temps.getImageSaison().get_width() - self.recBatiment.w,self.temps.getImageSaison().get_height())

        #DragAndDrop
        self.dragBatiment = None
        self.dragPlantation = None
        



    def gameLoop (self):
        while True:

            self.screen.blit(self.image.backgroundImage, (0,0))

            #CHAMPS------------------
            # Affichage des champs
            for champ in self.champs:
                champ.draw(self.screen, self.camera)

            for bat in self.batiment:
                bat.draw(self.screen, self.camera)
            #DEBUT BOUCLE INTERFACE------------------------

            #Onglet Information
            #pygame.draw.rect(self.screen, (0, 127, 0), self.recInformation)
            self.screen.blit(Game.imagestaticinfor,(self.coordonne_info.x,self.coordonne_info.y))

            # Météo
            self.screen.blit(self.temps.getImageSaison(), (0, self.screen.get_height() - 300))
            self.screen.blit(self.temps.iconSaison,(10,self.screen.get_height() - self.temps.iconSaison.get_height()))
            self.screen.blit(self.temps.tempsaisonImage,(10,self.screen.get_height() - self.temps.iconSaison.get_height() - 50))

            self.screen.blit(self.temps.nexticonSaison,(self.temps.getImageSaison().get_width() - self.temps.nexticonSaison.get_width(),self.screen.get_height() - self.temps.getImageSaison().get_height() +20))
            self.screen.blit(self.temps.tempsaisonImageDeuxPosiiton,(self.temps.getImageSaison().get_width() - self.temps.nexticonSaison.get_width(),self.screen.get_height() - self.temps.getImageSaison().get_height()))

            
            print(self.rectPlantation.w)
            print(self.rectPlantation.h)
            #Onglet plantation
            
            self.screen.blit(self.rectPlantationimage,(0,0))
            #Onglet tour suivant
            pygame.draw.rect(self.screen,(0, 127, 0),(self.recTourSuivant))
            self.screen.blit(self.tourSuivantModif, (self.recTourSuivant.x+ (self.recTourSuivant.w - self.tourSuivantModif.get_width())/2,
            self.recTourSuivant.y+ (self.recTourSuivant.h - self.tourSuivantModif.get_height())/2))

            for i,c in enumerate(typePlantation):
                x = self.rectPlantation.x + ( 0 if i%2 else 170) 
                y = self.rectPlantation.y + (i//2) * 200
                r = pygame.rect.Rect(x,y,c.iconStatic.get_width(),c.iconStatic.get_height()+ 30 )
                self.screen.blit(c.textStatic, (x,y))
                self.screen.blit(c.iconStatic,(x,y+30 ))
                if ( (r.collidepoint(pygame.mouse.get_pos()))):
                    pygame.draw.rect(self.screen,(138, 227, 237), r,1)
                    self.screen.blit(c.textDescriptionStatic,(self.recInformation.x,self.recInformation.y))
                    #self.screen.blit(self.text,(screen.get_width()*0.85,screen.get_height()*0.18))
            
        
                
                
            #Onglet batiment 
            self.screen.blit(self.rectBatimentimage,(self.temps.getImageSaison().get_width(),self.screen.get_height() - self.temps.getImageSaison().get_height()))
            for i,c in enumerate(typeBatiment):
                x = self.recBatiment.x + i* (c.iconStatic.get_width() + 30) +50
                y = self.recBatiment.y + 50
                r = pygame.rect.Rect(x,y,c.iconStatic.get_width() + 20 ,c.iconStatic.get_height()+ 30 )
                self.screen.blit(c.textStatic, (x,y))
                self.screen.blit(c.iconStatic,(x,y + 30))
                if ( (r.collidepoint(pygame.mouse.get_pos()))):
                    pygame.draw.rect(self.screen,(138, 227, 237), r,1)
                    self.screen.blit(c.textDescriptionStatic,(self.recInformation.x,self.recInformation.y))
                       
            # FIN BOUCLE INTERFACE ------------------------


            isChamp = False
            
            #

            
            if self.money < self.displayMoney:
                self.displayMoney -= min(444, self.displayMoney - self.money) # Si quelque chose coûte moins que 100, changer par -= min(100, self.displayMoney - self.money)
            elif self.money > self.displayMoney:
                self.displayMoney+= min(444, self.money - self.displayMoney) # Si quelque chose coûte moins que 100, changer par -= min(100, self.money - self.displayMoney)
            

            #self.displayMoney = self.money
            
            textMoney = police.render(str(self.displayMoney), True, (255,255,255))

            self.CoRecArgent = pygame.rect.Rect(self.screen.get_width(), 0, 100, 100)
            self.recArgent = pygame.draw.rect(self.screen,(255,0,0),(self.CoRecArgent))

            self.screen.blit(textMoney, (self.screen.get_width() - self.imageMoney.get_width() - textMoney.get_width(),self.imageMoney.get_height()/2))
            self.screen.blit(self.imageMoney, (self.screen.get_width() - self.imageMoney.get_width() , 0))


            for event in pygame.event.get():
                if event.type == pygame.QUIT or event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
                    exit()

                elif event.type == pygame.MOUSEMOTION:
                    
                    if event.buttons[2] == 1: #maintenir enfoncé clic droit
                        self.camera.setPosition(np.array(event.rel))
                    if event.buttons[0] == 1:#maintenir enfoncé clic gauche
                        if self.dragBatiment == None and self.dragPlantation == None:
                            for i,c in enumerate(typeBatiment):
                                x = self.recBatiment.x + i* (c.iconStatic.get_width() + 30) +50
                                y = self.recBatiment.y + 50
                                r = pygame.rect.Rect(x,y,c.iconStatic.get_width() + 20 ,c.iconStatic.get_height()+ 30 )
                                if ( (r.collidepoint(event.pos))):
                                    self.dragBatiment = c
                        if(self.dragBatiment):
                            self.screen.blit(self.dragBatiment.iconStatic, (event.pos))   


                        if self.dragPlantation == None and self.dragBatiment == None:
                            
                            for i,c in enumerate(typePlantation):

                                x = self.rectPlantation.x + ( 0 if i%2 else 170) 
                                y = self.rectPlantation.y + (i//2) * 200
                                r = pygame.rect.Rect(x,y,c.iconStatic.get_width() + 20 ,c.iconStatic.get_height()+ 30 )
                                if ( (r.collidepoint(event.pos))):
                                    self.dragPlantation = c
                        if(self.dragPlantation):
                            self.screen.blit(self.dragPlantation.iconStatic, (event.pos))

                                
                    else:
                        if self.dragPlantation:
                            for champ in self.champs:
                                if champ.rectScale.collidepoint(event.pos):
                                    print(champ)
                                    print(self.dragPlantation)
                                    if self.dragPlantation == Pesticide:
                                        print(champ.isInfeste)
                                        champ.isInfeste = False
                                        print(champ.isInfeste)

                                    elif isinstance(champ,TerrainVide):                                                                                                              
                                        self.champs.append(self.dragPlantation(champ.pos))
                                        self.champs.remove(champ)
                                        #Perdre l'argent
                                        variable = self.dragPlantation.montantAchat
                                        self.moneyDefile(-variable)
                                   
                                        
                        
                        if self.dragBatiment:
                            for champ in self.champs:
                                if champ.rectScale.collidepoint(event.pos):
                                    if isinstance(champ,TerrainVide):  
                                        self.batiment.append(self.dragBatiment(champ.pos))
                                       
                                        #Perdre l'argent
                                        variable = self.dragBatiment.montantAchat
                                        self.moneyDefile(-variable)

                                        if self.dragBatiment not in [Torche,Serre]:
                                            self.champs.remove(champ)
                                            
                            
                        self.dragPlantation = None
                        self.dragBatiment = None
                    

                        
                    for champ in self.champs + self.batiment:
                        if champ.rectScale.contains(event.pos[0],event.pos[1],0,0):
                            self.selectedChamp = champ
                            isChamp = True
                
                    if not isChamp:
                        self.selectedChamp = None

                    if (*event.pos,0,0) in self.recTourSuivant:
                        self.tourSuivantModif = pygame.transform.scale(self.tourSuivantOriginal, (200, 200))
                    else:
                        self.tourSuivantModif = pygame.transform.scale(self.tourSuivantOriginal, (100, 100))
                    
                
                
                elif event.type == pygame.MOUSEWHEEL:
                    self.camera.zoomInOut(event.y)

                # Achat d'un champ
                elif event.type == pygame.MOUSEBUTTONDOWN:
                
                    if event.button == 1:
                        if(self.recTourSuivant.collidepoint(event.pos)):
                            self.temps.NextTurn()
                            
                            if(self.temps.currentSeason == "Hiver"):
                                self.AideEtat()
                            

                            i = 0
                            for champ in self.champs:
                                
                                if type(champ) in typePlantation:
                                    if champ.isInfeste:
                                        champ.indiceImage = 4
                                    champ.plantationGrandit()
                                    if(random.random()< 0.10):
                                        champ.isInfeste = True


                        for champ in self.champs: 
                            if champ.rectScale.collidepoint(event.pos):
                                
                                if(champ.indiceImage > 3):
                                    self.champs.append(TerrainVide(champ.pos))
                                    self.champs.remove(champ)
                                elif(champ.indiceImage == 3):
                                    self.moneyDefile(champ.montantVente)
                                    self.champs.append(TerrainVide(champ.pos))
                                    self.champs.remove(champ)
                                    
                                 

                                if isinstance(champ, Buisson):
                                    #if self.money >= champ.prix:
                                    self.moneyDefile(-champ.prix)
                                    self.champs.append(champ.buyField())
                                    self.champs.remove(champ)
                
                                        

            if self.frame < self.buyFrame + 20:
                self.screen.blit(self.moneyChange, (self.screen.get_width() -200, (self.frame-self.buyFrame)*1.5))
                #self.screen.blit(self.moneyChange, (200, self.screen.get_height()-textMoney.get_height()*4+(self.frame-self.buyFrame)*1.5))

            if self.selectedChamp:
                self.selectedChamp.showInfo(self.screen,self.recInformation)
                

            pygame.display.update()
            self.clock.tick(50)
            self.frame += 1
        
    def moneyDefile(self,montant):
        self.moneyChange = police.render(str(montant), True, (200,0,0) if montant < 0 else (0,250,0) )
        self.buyFrame = self.frame
        self.money+= montant
        
    def AideEtat(self):
        self.moneyDefile(5000)

