import numpy as np
import pygame

police = pygame.font.SysFont("Alef", 22) #pygame.font.get_fonts() -> liste des fonts

class Infrastructure:

    def __init__ (self,pos,image):
        self.image = pygame.image.load(image)
        self.imageSize = np.array(self.image.get_size())
        self.pos = pos
        self.rect = pygame.rect.Rect(self.pos, self.image.get_rect().size)
        self.rectScale = self.rect       

        self.descripteurInfrastructure = {
            "temperature" : None,
        }
        self.imageSurfaceinfo = {
            
        }
        self.setInformation("temperature",2000)
        #self.setInformation("Occupe", True) 



    def draw (self, screen, camera):
        scaleImage = camera.scaleImage(self.image)

        if scaleImage: # != None
            self.imgZoom = scaleImage
            self.rectScale = pygame.rect.Rect(camera.convertLocation(self.pos), self.imgZoom.get_size())
        
        
        if hasattr(self,'imagebat'):
            scaleBat = camera.scaleImage(self.imagebat)
            if scaleBat:
                self.BatZoom = scaleBat
            varlongueur = camera.convertLocation(self.pos)   
            self.rectbatScal = pygame.rect.Rect(camera.convertLocation(self.pos), self.BatZoom.get_size())
            screen.blit(
            self.BatZoom, 
            (
                varlongueur[0] + 
                (self.rectScale.w-self.rectbatScal.w)
                /2,
                varlongueur[1] + 
                (self.rectScale.h-self.rectbatScal.h)
                /2)
            )
            
             


    def changeText (self, camera):
        scaleText = camera.scaleImage(self.text)
        if scaleText:
            self.zoomText = scaleText

    def setInformation(self,clef,valeur):
        self.descripteurInfrastructure[clef] = valeur
        self.imageSurfaceinfo[clef] = police.render(clef+ " :  "+ str(valeur),False,(0,0,0))

    def showInfo(self,screen,rectangle):
        i = 0
        for k,v in self.descripteurInfrastructure.items():
            screen.blit(self.imageSurfaceinfo[k],(rectangle.x,rectangle.y + i))
            i += 30


class Puit (Infrastructure):
    iconStatic = pygame.transform.scale(pygame.image.load('../assets/Batiment/puit.png'),(150,150))
    textStatic = police.render('Puits',False, (0,0,0))
    textDescriptionStatic = police.render("C'est un puit",False,(0,0,0))
    montantAchat = 2000
    def __init__ (self,pos):
        super().__init__(pos,'../assets/Plantation/champ.png')
        self.imagebat = pygame.transform.scale(pygame.image.load('../assets/Batiment/puit.png'),(120,120))

class ReservoirEau (Infrastructure):
    iconStatic = pygame.transform.scale(pygame.image.load('../assets/Batiment/storagetank.png'),(150,150))
    textStatic = police.render('Capteur eau de pluie',False, (0,0,0))
    textDescriptionStatic = police.render("Permet de capturer l'eau de pluit",False,(0,0,0))
    montantAchat = 3000
    def __init__ (self,pos):
        super().__init__(pos,'../assets/Plantation/champ.png')
        self.imagebat = pygame.transform.scale(pygame.image.load('../assets/Batiment/storagetank.png'),(120,120))

class Irrigation (Infrastructure):
    iconStatic = pygame.transform.scale(pygame.image.load('../assets/Batiment/irrigation.png'),(150,150))
    textStatic = police.render('Arrosoir automatique ',False, (0,0,0))
    textDescriptionStatic = police.render("Permet d'arroser les plantes",False,(0,0,0))
    montantAchat = 5000
    def __init__ (self,pos):
        super().__init__(pos,'../assets/Plantation/champ.png')
        self.imagebat = pygame.transform.scale(pygame.image.load('../assets/Batiment/irrigation.png'),(120,120))

class IrrigationGoutte (Infrastructure):
    iconStatic = pygame.transform.scale(pygame.image.load('../assets/Batiment/irrigationGoutte.png'),(150,150))
    textStatic = police.render('Système goutte à goutte',False, (0,0,0))
    textDescriptionStatic = police.render("Permet d'arroser les plantes en économisant l'eau",False,(0,0,0))
    montantAchat = 10000
    def __init__ (self,pos):
        super().__init__(pos,'../assets/Plantation/champ.png')
        self.imagebat = pygame.transform.scale(pygame.image.load('../assets/Batiment/irrigationGoutte.png'),(120,120))

class Serre (Infrastructure):
    iconoriginal = pygame.image.load('../assets/Batiment/serre.png')
    iconStatic = pygame.transform.scale(iconoriginal,(150,150))
    textStatic = police.render('Serre',False, (0,0,0))
    textDescriptionStatic = police.render("Permet de proteger les cultures du froid et de la chaleur",False,(0,0,0))
    montantAchat = 1500

    iconStaticCopie = pygame.transform.scale(iconoriginal.copy(), (250,200))

    iconStaticCopie.fill((255, 255, 255, 70), None, pygame.BLEND_RGBA_MULT)

    def __init__ (self,pos):
        super().__init__(pos,'../assets/Plantation/champ.png')
        self.champsAfecte = None
        #self.imagebat = pygame.transform.scale(pygame.image.load('../assets/serre.png'),(120,120))
    
    def draw (self, screen, camera):
        scaleImage = camera.scaleImage(Serre.iconStaticCopie)
        scaleChamp = camera.scaleImage(self.image)

        if scaleChamp :
            self.champZoom = scaleChamp
            self.champRect = pygame.rect.Rect(camera.convertLocation(self.pos),self.champZoom.get_size())
        if scaleImage: # != None
            self.imgZoom = scaleImage
            self.rectScale = pygame.rect.Rect(camera.convertLocation(self.pos), self.imgZoom.get_size())


        varlongueur = camera.convertLocation(self.pos)  
        screen.blit(self.imgZoom, (varlongueur[0]+ (self.champRect.w - self.rectScale.w)/2,varlongueur[1]+ (self.champRect.h - self.rectScale.h)/2))
                  

class Torche (Infrastructure):
    iconStatic = pygame.transform.scale(pygame.image.load('../assets/Batiment/torche.png'),(150,150))
    textStatic = police.render('Torche',False, (0,0,0))
    textDescriptionStatic = police.render("Permet de proteger les cultures du froid ",False,(0,0,0))
    montantAchat = 1000
    def __init__ (self,pos):
        super().__init__(pos,'../assets/Plantation/champ.png')
        self.zoneafecte = None
        #self.imagebat = pygame.transform.scale(pygame.image.load('../assets/torche.png'),(120,120))

typeBatiment = [Puit,ReservoirEau,Irrigation,IrrigationGoutte,Serre,Torche]